﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PeteBrown.SilverlightChat
{
    public partial class ChatBalloon : UserControl
    {
        public event EventHandler RemoveMe;

        public ChatBalloon()
        {
            InitializeComponent();

            Loaded += new RoutedEventHandler(ChatBalloon_Loaded);
        }

        public ChatBalloon(string message)
            : this()
        {
            ChatMessage.Text = message;
        }

        void ChatBalloon_Loaded(object sender, RoutedEventArgs e)
        {
            // Set up an event source that will tell the container when
            // we have completed our animation
            PopAndFade.Completed += new EventHandler(PopAndFade_Completed);
            PopAndFade.Begin();
        }

        void PopAndFade_Completed(object sender, EventArgs e)
        {
            if (RemoveMe != null)
                RemoveMe(this, new EventArgs());
        }

    }
}
